<?php

namespace CreoCode\ContaoPhotoswipe\Listener;

use Contao\File;

/**
 * Class Hooks
 */
class Hooks {

    /**
     * Disable libxml errors
     */
    public function __construct() {
        libxml_use_internal_errors(true);
    }
    
    /**
     * Enable libxml errors
     */
    public function __destruct() {
        libxml_use_internal_errors(false);
    }

    /**
     * Inject data-size attribute
     */
    public function getContentElement($objTemplate, $strBuffer) {
        if(empty($strBuffer)) {
            return $strBuffer;
        }
        $dom = new \DOMDocument();
        $dom->loadHTML('<?xml encoding="utf-8" ?>' . $strBuffer);
        $xPath = new \DOMXpath($dom);
        $linksFound = false;
        foreach($xPath->query('//a[@data-lightbox]') as $link) {
            $objFile = new File($link->getAttribute('href'));
            $link->setAttribute('data-size', implode('x', $objFile->imageViewSize));
            if (!$linksFound) {
                $linksFound = true;
            }
        }

        // If Links found return injected html else return buffer
        if ($linksFound) {
            return $dom->saveHTML();
        } else {
            return $strBuffer;
        }
        
    }
}